Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_drawAll.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_drawAll.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_drawAll.cpp	(revision 99)
@@ -21,5 +21,5 @@
     
     Entity *e = p.getEntity();
-    string s;
+    string s,com;
     s.append(e->getName());
     s.append(" : ");
@@ -27,4 +27,6 @@
     painter.setPen(Qt::black);
     painter.drawText(50,10,500,60,Qt::AlignCenter,QString::fromStdString(s));
+    com.append(e->getComment());//apparemment, il n'y a pas de commentaires 
+    painter.drawText(50,30,500,60,Qt::AlignCenter,QString::fromStdString(com));
     painter.setPen(Qt::blue);
 
Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Makefile	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Makefile	(revision 99)
@@ -1,8 +1,8 @@
 #############################################################################
 # Makefile for building: bin/Viewer
-# Generated by qmake (2.01a) (Qt 4.2.2) on: Wed May 30 20:51:15 2007
+# Generated by qmake (2.01a) (Qt 4.2.2) on: Wed May 30 23:13:07 2007
 # Project:  Viewer.pro
 # Template: app app
-# Command: /usr/local/Trolltech/Qt-4.2.2/bin/qmake -unix -o Makefile Viewer.pro
+# Command: /dsk/l1/misc/kane/qt-x11-opensource-4.2.2/bin/qmake -unix -o Makefile Viewer.pro
 #############################################################################
 
@@ -18,11 +18,11 @@
 LEXFLAGS      = 
 YACCFLAGS     = -d
-INCPATH       = -I/usr/local/Trolltech/Qt-4.2.2/mkspecs/linux-g++ -I. -I/usr/local/Trolltech/Qt-4.2.2/include/QtCore -I/usr/local/Trolltech/Qt-4.2.2/include/QtCore -I/usr/local/Trolltech/Qt-4.2.2/include/QtGui -I/usr/local/Trolltech/Qt-4.2.2/include/QtGui -I/usr/local/Trolltech/Qt-4.2.2/include/QtXml -I/usr/local/Trolltech/Qt-4.2.2/include/QtXml -I/usr/local/Trolltech/Qt-4.2.2/include -I. -IBdd/include -IGraphics/include -IParser/include -I../.. -I. -I.
+INCPATH       = -I/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/linux-g++ -I. -I/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/include/QtCore -I/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/include/QtCore -I/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/include/QtGui -I/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/include/QtGui -I/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/include/QtXml -I/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/include/QtXml -I/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/include -I. -IBdd/include -IGraphics/include -IParser/include -I../.. -I. -I.
 LINK          = g++
-LFLAGS        = -Wl,-rpath,/usr/local/Trolltech/Qt-4.2.2/lib
-LIBS          = $(SUBLIBS)  -L/usr/local/Trolltech/Qt-4.2.2/lib -lQtXml -L/root/qt-x11-opensource-src-4.2.2/lib -lQtGui -L/usr/X11R6/lib -lpng -lSM -lICE -lXi -lXrender -lXrandr -lXfixes -lXcursor -lXinerama -lfreetype -lfontconfig -lXext -lX11 -lQtCore -lz -lm -lglib-2.0 -lpthread -ldl
+LFLAGS        = -Wl,-rpath,/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/lib
+LIBS          = $(SUBLIBS)  -L/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/lib -lQtXml -L/dsk/l1/misc/kane/qt-x11-opensource-src-4.2.2/lib -lQtGui -L/usr/X11R6/lib -lpng -lSM -lICE -lXi -lXrender -lXrandr -lXfixes -lXcursor -lXinerama -lfreetype -lfontconfig -lXext -lX11 -lQtCore -lz -lm -lglib-2.0 -lpthread -ldl
 AR            = ar cqs
 RANLIB        = 
-QMAKE         = /usr/local/Trolltech/Qt-4.2.2/bin/qmake
+QMAKE         = /dsk/l1/misc/kane/qt-x11-opensource-4.2.2/bin/qmake
 TAR           = tar -cf
 COMPRESS      = gzip -9f
@@ -219,20 +219,20 @@
 		obj/Graphics_mouseEvent.o \
 		obj/moc_window.o
-DIST          = /usr/local/Trolltech/Qt-4.2.2/mkspecs/common/unix.conf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/common/g++.conf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/common/linux.conf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/qconfig.pri \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/qt_functions.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/qt_config.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/exclusive_builds.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/default_pre.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/debug.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/default_post.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/unix/thread.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/qt.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/moc.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/warn_on.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/resources.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/uic.prf \
+DIST          = /dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/common/unix.conf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/common/g++.conf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/common/linux.conf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/qconfig.pri \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/qt_functions.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/qt_config.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/exclusive_builds.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/default_pre.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/debug.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/default_post.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/unix/thread.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/qt.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/moc.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/warn_on.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/resources.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/uic.prf \
 		Viewer.pro
 QMAKE_TARGET  = Viewer
@@ -268,43 +268,43 @@
 	$(LINK) $(LFLAGS) -o $(TARGET) $(OBJECTS) $(OBJCOMP) $(LIBS)
 
-Makefile: Viewer.pro  /usr/local/Trolltech/Qt-4.2.2/mkspecs/linux-g++/qmake.conf /usr/local/Trolltech/Qt-4.2.2/mkspecs/common/unix.conf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/common/g++.conf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/common/linux.conf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/qconfig.pri \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/qt_functions.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/qt_config.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/exclusive_builds.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/default_pre.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/debug.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/default_post.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/unix/thread.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/qt.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/moc.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/warn_on.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/resources.prf \
-		/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/uic.prf \
-		/usr/local/Trolltech/Qt-4.2.2/lib/libQtXml.prl \
-		/usr/local/Trolltech/Qt-4.2.2/lib/libQtCore.prl \
-		/usr/local/Trolltech/Qt-4.2.2/lib/libQtGui.prl
+Makefile: Viewer.pro  /dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/linux-g++/qmake.conf /dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/common/unix.conf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/common/g++.conf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/common/linux.conf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/qconfig.pri \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/qt_functions.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/qt_config.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/exclusive_builds.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/default_pre.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/debug.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/default_post.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/unix/thread.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/qt.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/moc.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/warn_on.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/resources.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/uic.prf \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/lib/libQtXml.prl \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/lib/libQtCore.prl \
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/lib/libQtGui.prl
 	$(QMAKE) -unix -o Makefile Viewer.pro
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/common/unix.conf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/common/g++.conf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/common/linux.conf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/qconfig.pri:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/qt_functions.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/qt_config.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/exclusive_builds.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/default_pre.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/debug.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/default_post.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/unix/thread.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/qt.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/moc.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/warn_on.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/resources.prf:
-/usr/local/Trolltech/Qt-4.2.2/mkspecs/features/uic.prf:
-/usr/local/Trolltech/Qt-4.2.2/lib/libQtXml.prl:
-/usr/local/Trolltech/Qt-4.2.2/lib/libQtCore.prl:
-/usr/local/Trolltech/Qt-4.2.2/lib/libQtGui.prl:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/common/unix.conf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/common/g++.conf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/common/linux.conf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/qconfig.pri:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/qt_functions.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/qt_config.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/exclusive_builds.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/default_pre.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/debug.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/default_post.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/unix/thread.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/qt.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/moc.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/warn_on.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/resources.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/mkspecs/features/uic.prf:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/lib/libQtXml.prl:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/lib/libQtCore.prl:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/lib/libQtGui.prl:
 qmake:  FORCE
 	@$(QMAKE) -unix -o Makefile Viewer.pro
@@ -329,5 +329,5 @@
 
 
-/usr/local/Trolltech/Qt-4.2.2/bin/moc:
+/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/bin/moc:
 	(cd $(QTDIR)/src/tools/moc && $(MAKE))
 
@@ -340,6 +340,6 @@
 	-$(DEL_FILE) moc_window.cpp
 moc_window.cpp: Graphics/include/window.h \
-		/usr/local/Trolltech/Qt-4.2.2/bin/moc
-	/usr/local/Trolltech/Qt-4.2.2/bin/moc $(DEFINES) $(INCPATH) Graphics/include/window.h -o moc_window.cpp
+		/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/bin/moc
+	/dsk/l1/misc/kane/qt-x11-opensource-4.2.2/bin/moc $(DEFINES) $(INCPATH) Graphics/include/window.h -o moc_window.cpp
 
 compiler_rcc_make_all:
Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/moc_window.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/moc_window.cpp	(revision 99)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/moc_window.cpp	(revision 99)
@@ -0,0 +1,119 @@
+/****************************************************************************
+** Meta object code from reading C++ file 'window.h'
+**
+** Created: Thu May 31 11:18:54 2007
+**      by: The Qt Meta Object Compiler version 59 (Qt 4.2.2)
+**
+** WARNING! All changes made in this file will be lost!
+*****************************************************************************/
+
+#include "Graphics/include/window.h"
+#if !defined(Q_MOC_OUTPUT_REVISION)
+#error "The header file 'window.h' doesn't include <QObject>."
+#elif Q_MOC_OUTPUT_REVISION != 59
+#error "This file was generated using the moc from 4.2.2. It"
+#error "cannot be used with the include files from this version of Qt."
+#error "(The moc has changed too much.)"
+#endif
+
+static const uint qt_meta_data_morpheo__tools__viewer__graphics__Window[] = {
+
+ // content:
+       1,       // revision
+       0,       // classname
+       0,    0, // classinfo
+      22,   10, // methods
+       0,    0, // properties
+       0,    0, // enums/sets
+
+ // slots: signature, parameters, type, tag, flags
+      42,   41,   41,   41, 0x08,
+      50,   41,   41,   41, 0x08,
+      64,   41,   41,   41, 0x08,
+      72,   41,   41,   41, 0x08,
+      82,   41,   41,   41, 0x08,
+      94,   41,   41,   41, 0x08,
+     103,   41,   41,   41, 0x08,
+     111,   41,   41,   41, 0x08,
+     120,   41,   41,   41, 0x08,
+     130,   41,   41,   41, 0x08,
+     141,   41,   41,   41, 0x08,
+     155,   41,   41,   41, 0x08,
+     164,   41,   41,   41, 0x08,
+     180,   41,   41,   41, 0x08,
+     194,   41,   41,   41, 0x08,
+     203,   41,   41,   41, 0x08,
+     221,   41,   41,   41, 0x08,
+     236,   41,   41,   41, 0x08,
+     244,   41,   41,   41, 0x08,
+     264,   41,   41,   41, 0x08,
+     275,  273,   41,   41, 0x08,
+     306,  304,   41,   41, 0x08,
+
+       0        // eod
+};
+
+static const char qt_meta_stringdata_morpheo__tools__viewer__graphics__Window[] = {
+    "morpheo::tools::viewer::graphics::Window\0"
+    "\0_open()\0_open_error()\0_save()\0_saveAs()\0"
+    "_saveAsOk()\0_close()\0_quit()\0_quit2()\0"
+    "_zoomIn()\0_zoomOut()\0_defautZoom()\0"
+    "_level()\0_informations()\0_parameters()\0"
+    "_about()\0_component_name()\0_signal_name()\0"
+    "_back()\0_cancel_selection()\0_apply()\0"
+    "s\0currentIndexChanged(QString)\0i\0"
+    "valueChanged(int)\0"
+};
+
+const QMetaObject morpheo::tools::viewer::graphics::Window::staticMetaObject = {
+    { &QMainWindow::staticMetaObject, qt_meta_stringdata_morpheo__tools__viewer__graphics__Window,
+      qt_meta_data_morpheo__tools__viewer__graphics__Window, 0 }
+};
+
+const QMetaObject *morpheo::tools::viewer::graphics::Window::metaObject() const
+{
+    return &staticMetaObject;
+}
+
+void *morpheo::tools::viewer::graphics::Window::qt_metacast(const char *_clname)
+{
+    if (!_clname) return 0;
+    if (!strcmp(_clname, qt_meta_stringdata_morpheo__tools__viewer__graphics__Window))
+	return static_cast<void*>(const_cast<Window*>(this));
+    return QMainWindow::qt_metacast(_clname);
+}
+
+int morpheo::tools::viewer::graphics::Window::qt_metacall(QMetaObject::Call _c, int _id, void **_a)
+{
+    _id = QMainWindow::qt_metacall(_c, _id, _a);
+    if (_id < 0)
+        return _id;
+    if (_c == QMetaObject::InvokeMetaMethod) {
+        switch (_id) {
+        case 0: _open(); break;
+        case 1: _open_error(); break;
+        case 2: _save(); break;
+        case 3: _saveAs(); break;
+        case 4: _saveAsOk(); break;
+        case 5: _close(); break;
+        case 6: _quit(); break;
+        case 7: _quit2(); break;
+        case 8: _zoomIn(); break;
+        case 9: _zoomOut(); break;
+        case 10: _defautZoom(); break;
+        case 11: _level(); break;
+        case 12: _informations(); break;
+        case 13: _parameters(); break;
+        case 14: _about(); break;
+        case 15: _component_name(); break;
+        case 16: _signal_name(); break;
+        case 17: _back(); break;
+        case 18: _cancel_selection(); break;
+        case 19: _apply(); break;
+        case 20: currentIndexChanged((*reinterpret_cast< QString(*)>(_a[1]))); break;
+        case 21: valueChanged((*reinterpret_cast< int(*)>(_a[1]))); break;
+        }
+        _id -= 22;
+    }
+    return _id;
+}